/*
 * messages.c --- some common messages functions
 * 
 * Copyright (c) 2019 Mariano Alvarez Fernandez (malfer@telefonica.net)
 *
 * This file is part of FEdit, a visual font editor for the MGRX font format
 *
 * FEdit is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FEdit is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FEdit. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <grgui.h>
#include "fedit.h"

static char sout1[201];
static char sout2[201];
static char sout3[201];
static char sout4[201];
static char *sout[4] = {sout1, sout2, sout3, sout4};

void ShowError(char *s)
{
    strcpy(sout1, s);
    
    GUICDialogInfo("Error", (void **)sout, 1, "Ok");
}

void ShowError2(char *s1, char *s2)
{
    strcpy(sout1, s1);
    strcpy(sout2, s2);
    
    GUICDialogInfo("Error", (void **)sout, 2, "Ok");
}

void ShowError2cat(char *s1, char *s2)
{
    strcpy(sout1, s1);
    strcat(sout1, s2);
    
    GUICDialogInfo("Error", (void **)sout, 1, "Ok");
}

void ShowErrorReqBoxInvalid(int width, int height)
{
    sprintf(sout1, "Requested font box %dx%d not supported", width, height);
    sprintf(sout2, "Minimal box 4x4, maximun %dx%d, try again", MAXBOX_W, MAXBOX_H);
    
    GUICDialogInfo("Error", (void **)sout, 2, "Ok");
}

int WarnContinue(char *s1, char *s2)
{
    strcpy(sout1, s1);
    strcpy(sout2, s2);
    sprintf(sout3, "Do you want to continue?");

    return GUICDialogYesNo("Warning", (void **)sout, 3,  "Yes", "No");
}

int ConfirmContinue(char *s1, char *s2)
{
    strcpy(sout1, s1);
    strcpy(sout2, s2);
    sprintf(sout3, "Select 'Yes' to continue");

    return GUICDialogYesNo("Confirmation", (void **)sout, 3,  "Yes", "No");
}
