#include <unistd.h>
#include <stdio.h>
#include <string.h>
#ifdef  __WIN32__
#include <windows.h>
#endif
#include "fdv_grx.h"

int main(int argc, char **argv)
{
    FILE *f, *frights;
    GrFontFileHeaderGRX fhdr;
    long wtsize, fsize;
    unsigned char c;
    long lastbyte;

    if (argc < 3) {
        printf("Usage: putright fontname rightsfile\n");
        return 1;
    }

    f = fopen(argv[1], "rb+");
    if (f == NULL) {
        printf("Error opening %s\n", argv[1]);
        return 1;
    }

    frights = fopen(argv[2], "rb");
    if (frights == NULL) {
        printf("Error opening %s\n", argv[2]);
        return 1;
    }

    if (fread(&fhdr,sizeof(fhdr),1,f) != 1) {
        printf("Reading header failed\n");
        return 1;
    }

    if (fhdr.magic != GRX_FONTMAGIC) {
        printf("font magic doesn't fit: %lx != %lx\n",
               (unsigned long)fhdr.magic,(unsigned long)GRX_FONTMAGIC);
        return 1;
    }

    wtsize = 0;
    if (!fhdr.isfixed) {
        wtsize = sizeof(short) * (fhdr.maxchar - fhdr.minchar + 1);
    }

    fsize = sizeof(GrFontFileHeaderGRX) + wtsize + fhdr.bmpsize;

    fseek(f, fsize, SEEK_SET);

    while (fread(&c, sizeof(unsigned char), 1, frights) == 1) {
        fwrite(&c, sizeof(unsigned char), 1, f);
    }

    lastbyte = ftell(f);

    fclose(frights);

#ifdef  __WIN32__
    HANDLE hf = (HANDLE)_get_osfhandle(_fileno(f));
    SetEndOfFile(hf);
    fclose(f);
#else
    fclose(f);
    truncate(argv[1], lastbyte);
#endif
    
    return 0;
}
